=== debian/changelog ===
open62541 (1.4.6-1) unstable; urgency=low

  * Initial release (closes: #985909)

 -- Julius Pfrommer <julius.pfrommer@web.de>  Sun, 06 Oct 2024 16:57:30 +0200
